* Version 1.6, tested on Amiga Qdos 322, JM & JSL1 ROMs, 20/2/95, 628 bytes
*
* ***********************
* *  QDOS System Calls  *
* ***********************
*
*
mt_inf          equ     $00
mt_cjob         equ     $01
mt_jinf         equ     $02
mt_rjob         equ     $04
mt_frjob        equ     $05
mt_free         equ     $06
mt_trapv        equ     $07
mt_susjb        equ     $08
mt_reljb        equ     $09
mt_activ        equ     $0a
mt_prior        equ     $0b
mt_alloc        equ     $0c
mt_lnkfr        equ     $0d
mt_alres        equ     $0e
mt_reres        equ     $0f
mt_dmode        equ     $10
mt_ipcom        equ     $11
mt_baud         equ     $12
mt_rclck        equ     $13
mt_sclck        equ     $14
mt_aclck        equ     $15
mt_albas        equ     $16
mt_rebas        equ     $17
mt_alchp        equ     $18
mt_rechp        equ     $19
mt_lxint        equ     $1a
mt_rxint        equ     $1b
mt_lpoll        equ     $1c
mt_rpoll        equ     $1d
mt_lschd        equ     $1e
mt_rschd        equ     $1f
mt_liod         equ     $20
mt_riod         equ     $21
mt_ldd          equ     $22
mt_rdd          equ     $23
*
* TRAP #2 keys
*
io_open         equ     $01
io_close        equ     $02
io_formt        equ     $03
io_delet        equ     $04
*
* TRAP #3 keys
*
io_fbyte        equ     $01
io_fline        equ     $02
io_fstrg        equ     $03
io_edlin        equ     $04
io_sbyte        equ     $05
io_sstrg        equ     $07
sd_extop        equ     $09
sd_pxenq        equ     $0a
sd_chenq        equ     $0b
sd_bordr        equ     $0c
sd_wdef         equ     $0d
sd_cure         equ     $0e
sd_curs         equ     $0f
sd_pos          equ     $10
sd_tab          equ     $11
sd_nl           equ     $12
sd_pcol         equ     $13
sd_ncol         equ     $14
sd_prow         equ     $15
sd_nrow         equ     $16
sd_pixp         equ     $17
sd_scrol        equ     $18
sd_scrtp        equ     $19
sd_scrbt        equ     $1a
sd_pan          equ     $1b
sd_panln        equ     $1e
sd_panrt        equ     $1f
sd_clear        equ     $20
sd_clrtp        equ     $21
sd_clrbt        equ     $22
sd_clrln        equ     $23
sd_clrrt        equ     $24
sd_fount        equ     $25
sd_recol        equ     $26
sd_setpa        equ     $27
sd_setst        equ     $28
sd_setin        equ     $29
sd_setfl        equ     $2a
sd_setul        equ     $2b
sd_setmd        equ     $2c
sd_setsz        equ     $2d
sd_fill         equ     $2e
sd_donl         equ     $2f
sd_point        equ     $30
sd_line         equ     $31
sd_arc          equ     $32
sd_elips        equ     $33
sd_scale        equ     $34
sd_flood        equ     $35
sd_gcur         equ     $36
fs_check        equ     $40
fs_flush        equ     $41
fs_posab        equ     $42
fs_posre        equ     $43
fs_mdinf        equ     $45
fs_heads        equ     $46
fs_headr        equ     $47
fs_load         equ     $48
fs_save         equ     $49
fs_renam        equ     $4a
fs_trunc        equ     $4b
*
* QDOS Vectors
*
mm_alchp        equ     $c0
mm_rechp        equ     $c2
ut_windw        equ     $c4
ut_con          equ     $c6
ut_scr          equ     $c8
ut_err0         equ     $ca
ut_err          equ     $cc
ut_mint         equ     $ce
ut_mtext        equ     $d0
ut_link         equ     $d2
ut_unlnk        equ     $d4
mm_alloc        equ     $d8
mm_lnkfr        equ     $da
io_qset         equ     $dc
io_qtest        equ     $de
io_qin          equ     $e0
io_qout         equ     $e2
io_qeof         equ     $e4
ut_cstr         equ     $e6
io_serq         equ     $e8
io_serio        equ     $ea
cn_date         equ     $ec
cn_day          equ     $ee
cn_ftod         equ     $f0
cn_itod         equ     $f2
cn_itobb        equ     $f4
cn_itobw        equ     $f6
cn_itobl        equ     $f8
cn_itohb        equ     $fa
cn_itohw        equ     $fc
cn_itohl        equ     $fe
cn_dtof         equ     $100
cn_dtoi         equ     $102
cn_btoib        equ     $104
cn_btoiw        equ     $106
cn_btoil        equ     $108
cn_htoib        equ     $10a
cn_htoiw        equ     $10c
cn_htoil        equ     $10e
bp_init         equ     $110
ca_gtint        equ     $112
ca_gtfp         equ     $114
ca_gtstr        equ     $116
ca_gtlin        equ     $118
bv_chrix        equ     $11a
ri_exec         equ     $11c
ri_execb        equ     $11e
bp_let          equ     $120
io_name         equ     $122
md_read         equ     $124
md_write        equ     $126
md_verin        equ     $128
md_sectr        equ     $12a
*
* Qdos error codes
*
err_nc          equ     -1
err_nj          equ     -2
err_om          equ     -3
err_or          equ     -4
err_bo          equ     -5
err_no          equ     -6
err_nf          equ     -7
err_ex          equ     -8
err_iu          equ     -9
err_ef          equ     -10
err_df          equ     -11
err_bn          equ     -12
err_te          equ     -13
err_ff          equ     -14 
err_bp          equ     -15
err_fe          equ     -16
err_xp          equ     -17
err_ov          equ     -18
err_ni          equ     -19
err_ro          equ     -20
err_bl          equ     -21
*
* Useful System Variable offsets
*
sv_ident        equ     $00
sv_cheap        equ     $04
sv_chpfr        equ     $08
sv_free         equ     $0c
sv_basic        equ     $10
sv_transp       equ     $14
sv_trnsfr       equ     $18
sv_respr        equ     $1c
sv_ramt         equ     $20
sv_rand         equ     $2e
sv_pollm        equ     $30
sv_tvmod        equ     $32
sv_scrst        equ     $34
sv_pcint        equ     $35
sv_netnr        equ     $37
sv_i2lst        equ     $38
sv_plist        equ     $3c
sv_shlst        equ     $40
sv_drlst        equ     $44
sv_ddlst        equ     $48
sv_keyq         equ     $4c
sv_chbas        equ     $78
sv_chtop        equ     $7c
sv_arbuf        equ     $8a
sv_ardel        equ     $8c
sv_arfrq        equ     $8e
sv_cqch         equ     $92
sv_sound        equ     $96
sv_ser1c        equ     $98
sv_ser2c        equ     $9c
sv_tmode        equ     $a0
sv_csub         equ     $a2
sv_mdrun        equ     $ee
sv_mddid        equ     $f0
sv_mdsta        equ     $f8
sv_fsdef        equ     $100
sv_stacb        equ     $140
sv_stact        equ     $480
*
* Useful SuperBASIC Variables
*
bv_bfbas        equ     $00
bv_bfp          equ     $04
bv_tkbas        equ     $08
bv_tkp          equ     $0c
bv_pfbas        equ     $10
bv_pfp          equ     $14
bv_ntbas        equ     $18
bv_ntp          equ     $1c
bv_nlbas        equ     $20
bv_nlp          equ     $24
bv_vvbas        equ     $28
bv_vvp          equ     $2c
bv_chbas        equ     $30
bv_chp          equ     $34
bv_rtbas        equ     $38
bv_rtp          equ     $3c
bv_lnbas        equ     $40
bv_lnp          equ     $44
bv_btp          equ     $48
bv_btbas        equ     $4c
bv_tgp          equ     $50
bv_tgbas        equ     $54
bv_rip          equ     $58
bv_ribas        equ     $5c
bv_ssp          equ     $60
bv_ssbas        equ     $64
bv_vvfree       equ     $72
*
*********************************************************************
*  Three new functions:  _DEF%, _NAME$ and _DEF$ .                  *
*  _DEFs put up a menu with all the SuperBASIC procedures and       *
*  functions in the name table.                                     *
*  The up and down arrow keys are used to select one of the         *
*  procedures, and when ENTER is pressed _DEF$ return the name of   *
*  the procedure or _DEF% return the line number of the DEFine-     *
*  statement.                                                       *
*  If ESC is pressed the functions stop with a NOT COMPLETE error.  *
*  If no procedures or functions are defined a NOT FOUND error is   *
*  reported.                                                        *
*  The number of procedures or functions that are included in the   *
*  menu depends on the size of SuperBASIC's BUFFER area. Two bytes  *
*  are used for each name in the menu, so all QLs allow 64+ names.  *
*  DEF functions accept one optional parameter, a SB channel number *
*  default #2. NAME$ takes one integer, the Name Table Index (0+)   *
*  If there are more procedures than will fit in the window, the    *
*  window will scroll if you try to move the cursor past the bottom *
*  or top. If a name is too long to fit on a line it is truncated.  *
*                                                                   *
*  The code is assembled with the Computer One assembler on a QL    *
*  with Minerva 1.79 ROM. Modified by SNG for Hisoft Devpac and     *
*  all QL & THOR ROMs; _NAME$ added; line table handling fixed.     *
*                                                                   *
*   Anders Hartzelius 1991, DIY changes  1991,95 Simon N Goodwin  *
*                                                                   *
*********************************************************************
*
enter           equ     $0a              Code for ENTER key
space           equ     32               Code for SPACE bar
esc             equ     $1b              ESC
up              equ     $d0              Up arrow
down            equ     $d8              Down arrow
*
start           lea.l   define,a1        Load address of definitions
                movea.w bp_init\w,a2     Fetch the ROM vector word
                jmp     (a2)             Initiate the new functions
*
name            moveq   #0,d5            Clear high bytes
                bsr.s   get_an_int       Pick up the parameter
                lsl.w   #3,d5            Multiply 0-8191 by 8 fast
                movea.l 32(a6),a4        Find the Name List offset
                movea.l 24(a6),a5        Find the Name Table offset
                adda.l  d5,a5
                cmpa.l  28(a6),a5        Check against end of Table
                bmi.s   check_list
bad_index       moveq   #err_bp,d0       Bad parameter, no such name
                rts
check_list      move.w  2(a6,a5.l),d1    Pick up Name List vector
                addq.w  #1,d1            Check it records a name
                beq.s   bad_index
                moveq   #1,d7            Indicate the result type
                bra     stacker
*
get_an_int      movea.w ca_gtint\w,a2    Yes: fetch channel number
                jsr     (a2)             Get integer
                bne.s   deep_err              Error ?
                subq.l  #1,d3            One parameter ?
                beq.s   par_ok           
bad_param       moveq   #err_bp,d0       Bad parameter
deep_err        bra     quit_out         Report to basic
par_ok          move.w  0(a1,a6.l),d5    D5:=parameter
                bmi.s   bad_param
                addq.l  #2,bv_rip(a6)    Tidy RI Maths Stack
err             rts
*
defn            moveq   #3,d7            Flag type for _DEF%
                bra.s   def
defs            moveq   #1,d7            Flag type for _DEF$
def             swap    d7               D7 is used for two purposes
                moveq   #2,d5            Default channel
                cmpa.l  a3,a5            Any parameters ?
                beq.s   default          No: use default channel
                bsr.s   get_an_int       Check for one integer param
default         moveq   #err_no,d0       Posit Channel not open
                mulu    #40,d5           D5:=offset in channel table
                add.l   bv_chbas(a6),d5  Add base of channel table
                cmp.l   bv_chp(a6),d5    D5 -> past end ?
                bge.s   err              Yes: report error
                move.l  0(a6,d5.l),d5    D5:= channel id
                bmi.s   err              Channel closed ?
*
* Prepare the menu window
*
                move.l  d5,a0            A0:= channel id
                moveq   #-1,d3           Time out
                moveq   #sd_clear,d0    
                bsr     trap3            CLS
                lea.l   get_csizes,a2    Load address of code
                moveq   #sd_extop,d0     Call extended operation
                bsr     trap3           
                move.w  d1,d7            D7.W := width in chars
                move.l  d1,d4            D4.HW := Char. height
                lea.l   get_colours,a2   Load address of code
                moveq   #sd_extop,d0     Call extended operation
                bsr     trap3
                move.l  d1,d5            D5:= ink & strip
*
* Point at SuperBASIC tables and work out the buffer size
*
                movea.l bv_ntbas(a6),a5  Base of name table
                movea.l bv_ntp(a6),a3    End of name table
                movea.l bv_nlbas(a6),a4  Base of name list
                movea.l (a6),a2          Base of buffer
                move.l  bv_tkbas(a6),d6  D6 -> Limit of buffer
                sub.l   a2,d6            D6 is buffer size (bytes)
                lsr.l   #1,d6            D6 is buffer size in words
*
* Scan the Name Table and display SuperBASIC PROC and FN names
*
                clr.w   d4               Reset Window full flag
nt_loop         addq.l  #8,a5            Next entry in name table
                cmpa.l  a5,a3            End of name table ?
                beq.s   end_nt
                move.b  0(a5,a6.l),d1    D1:= name type
                subq.b  #4,d1            SuperBASIC Procedure ?
                beq.s   proc_fn
                subq.b  #1,d1            SuperBASIC Function ?
                bne.s   nt_loop
proc_fn         subq.l  #1,d6            Room for one proc / fn less
                beq.s   end_nt           Don't overflow the buffer
                move.l  a5,d1
                sub.l   bv_ntbas(a6),d1  Relative to start of Table
                move.w  d1,0(a2,a6.l)    Buffer offset in name table
                addq.l  #2,a2
                tst.w   d4               Test window full flag
                bne.s   nt_loop          No printout if set
                bsr     print_name       
                moveq   #sd_nl,d0        New line
                bsr     trap3
                beq.s   nt_loop          Jump if not ERR_OR
                addq.w  #1,d4            Window full
                bra.s   nt_loop          Next entry in NT
*
end_nt          movea.l (a6),a3          Anything in the buffer ?
                cmpa.l  a3,a2
                bne.s   ok               
                moveq   #err_nf,d0       Not found
                rts                      Quit if no proc/fn
ok              lea.l   2(a3),a1         Perhaps there's only 1 ?
                cmpa.l  a1,a2
                bne.s   choose           If more, use the menu
                moveq   #0,d1            Prepare for unsigned maths
                move.w  0(a3,a6.l),d1    D1:= index in name table
                add.l   bv_ntbas(a6),d1
                movea.l d1,a5            A5 is offset inside BASIC
                bra     done             Return the only name known
*
* Highlight the first name and allow selection from the menu
*
choose          moveq   #0,d1            Column
                moveq   #0,d2            Row
                moveq   #sd_pos,d0      
                bsr     trap3            AT #X,0,0
                swap    d4               Retrieve char. height.W
move_loop       moveq   #0,d1            Prepare for unsigned maths
                move.w  0(a3,a6.l),d1    D1:= index in name table
                add.l   bv_ntbas(a6),d1  Relate to start of Table
                movea.l d1,a5            A5 is offset inside BASIC
                bsr     invert           Inverted video
                bsr.s   print_name
                bsr     invert           Revert
key_loop        moveq   #io_fbyte,d0
                bsr     trap3            Get keypress
                cmp.b   #esc,d1          ESC ?
                bne.s   test_enter
                moveq   #err_nc,d0       Not complete
                bra     return           Return to basic
test_enter      cmp.b   #enter,d1        ENTER ?
                beq     done
                cmp.b   #space,d1        SPACE ?
                beq     done
                cmp.b   #up,d1           UP ?
                bne.s   test_down
                cmpa.l  (a6),a3          First entry ?
                beq.s   key_loop         Yes: ignore
                subq.l  #2,a3            No: previous entry
                moveq   #sd_prow,d6      Cursor up
                bra.s   arrow            Move cursor
test_down       cmp.b   #down,d1         DOWN ?
                bne.s   key_loop
                moveq   #sd_nrow,d6      Cursor down
                addq.l  #2,a3            Next entry
                cmpa.l  a2,a3            Past the last entry ?
                bne.s   arrow            No: move cursor
                subq.l  #2,a3            Yes: stay at the end
                bra.s   key_loop         Wait for keypress
*
arrow           moveq   #0,d1            First pos on line
                moveq   #sd_tab,d0       Move cursor
                bsr.s   trap3            to start of line.
                bsr.s   print_name
                move.l  d6,d0            Move cursor up / down
                bsr.s   trap3           
                beq.s   no_scroll        Out of range ?
                moveq   #sd_scrol,d0     Yes: scroll window
                move.w  d4,d1            Scroll one line
                cmp.w   #sd_prow,d6      Which direction ?
                beq.s   scroll           Scroll down
                neg.w   d1               Scroll up
scroll          bsr.s   trap3            
no_scroll       moveq   #0,d1            First pos on line
                moveq   #sd_tab,d0       Move cursor
                bsr.s   trap3
                bra.s   move_loop        Wait for keypress
*
print_name      moveq   #0,d0            Prepare for unsigned sums
                move.w  2(a5,a6.l),d0    D0 -> entry in name list
                add.l   a4,d0            Add NL base address
                movea.l d0,a1
                moveq   #0,d2            Clear high bytes of D2
                move.b  0(a1,a6.l),d2    D2:= name length
                cmp.w   d7,d2            Name too long ?
                bmi.s   len_ok
                move.w  d7,d2            Truncate name to fit window
len_ok          addq.l  #1,a1            A1 -> name
                moveq   #io_sstrg,d0     Print string
                trap    #4               Signal A6 relative
*
trap3           trap    #3               IO trap
                tst.l   d0               Error ?
                beq.s   return           No: return to caller
                cmp.w   #err_or,d0       Out of range ?
                beq.s   return           Yes: return to caller
quit_out        addq.l  #4,a7            Return to earlier call
return          tst.l   d0
                rts
*
invert          move.l  d5,d1            D1:=previous ink / strip
                swap    d5               Ink:=strip , strip:=ink
                moveq   #sd_setst,d0    
                bsr.s   trap3            Set strip to ink
                swap    d1
                moveq   #sd_setin,d0     Set ink to strip
                bra.s   trap3            Call IO trap
*
done            clr.w   d7
                swap    d7               Retrieve the % / $ flag
stacker         movea.l bv_rip(a6),a1    A1 -> the RI Maths Stack
                moveq   #2,d1            At least 2 bytes needed
                cmp.b   #3,d7            Return % or $  ?
                beq.s   alloc            Jump if %
                moveq   #0,d0            Clear high bytes
                move.w  2(a5,a6.l),d0    Pick up offset, 0..65535
                adda.l  d0,a4            A4 -> name
                add.b   0(a4,a6.l),d1    D1:= 2 + name length
                addq.w  #1,d1            Make length
                bclr    #0,d1            even.
alloc           move.l  d1,d6            Save number of bytes
                movea.w bv_chrix\w,a2    Request space on 
                jsr     (a2)             Maths Stack.
                movea.l bv_rip(a6),a1    Fetch new ri-stack
                suba.l  d6,a1            Adjust pointer
                move.l  a1,bv_rip(a6)   
                cmp.b   #3,d7                  Return % or $ ?
                bne.s   string                 Jump if $ 
                move.w  4(a5,a6.l),0(a1,a6.l)  Stack line No.
goodbye         move.l  d7,d4                  Result type
no_problem      moveq   #0,d0                  No error
                rts
*
string          subq.w  #2,d6                  Adjust count
                clr.b   0(a1,a6.l)             Clear length.H
copy            move.b  0(a4,a6.l),1(a1,a6.l)  Copy bytes
                addq.l  #1,a4       
                addq.l  #1,a1            Adjust pointers
                dbra    d6,copy          Copy the whole name
                bra.s   goodbye          Return to BASIC
*
get_colours     moveq   #0,d1            Clear odd bytes of D1
                move.b  69(a0),d1        Strip
                swap    d1               Make room for ink
                move.b  70(a0),d1        Ink
                bra.s   no_problem
*
get_csizes      moveq   #0,d1            Clear high word of D1
                move.w  28(a0),d1        XSIZE
                move.w  38(a0),d2        XINC
                divu    d2,d1            D1.W := number of chars
                subq.w  #1,d1            Don't use last column
                swap    d1
                move.w  40(a0),d1        Put YINC in high word
                swap    d1
                bra.s   no_problem
*
define          dc.w    0,0,3            No procedures 3 functions
                dc.w    name-*           Offset to code
                dc.b    6,"_NAME$"       Name length and text
                ds.w    0                Align to a word boundary
                dc.w    defs-*           Offset to code
                dc.b    5,"_DEF$"        Name length and text
                ds.w    0                Align to a word boundary
                dc.w    defn-*           Offset to code
                dc.b    5,"_DEF%"        Name length and text
                ds.w    0                Align to a word boundary
                dc.w    0                ** FIX 20/2/95 **
                end

