* QL WORLD DIY TOOLKIT - REPLACE command
* Ver. 0.3, Copyright 1988 Simon N Goodwin.
*
start      lea.l    define,a1
           move.w   $110,a2         BP.INIT vector
           jmp      (a2)
*
define     dc.w     1               One procedure
           dc.w     replace-*
           dc.b     7,'REPLACE'
           dc.w     0
           dc.w     0,0             No functions
*
replace    lea.l    2*8(a3),a0
           cmpa.l   a0,a5           Two parameters?
           beq.s    two_params
bad_param  moveq    #-15,d0
bad_exit   rts
*
two_params move.w   2(a3,a6.l),d1   Index to be found
           bmi.s    bad_param       Reject expressions
           move.w   10(a3,a6.l),d2  Replacement index
           bmi.s    bad_param
*
* Search the program; D5 is the latest line number
*
           move.l   16(a6),a0       BV.PFBAS -> program
           move.l   20(a6),d7       BV.PFP -> end of prog
*
next_token addq.l   #2,a0
get_token  cmp.l    a0,d7           At or past the end?
           bls.s    all_done
           move.b   0(a0,a6.l),d0   D0 is token type
           addq.l   #2,a0           Skip over token word
*
           cmp.b    #240,d0         FLOATING POINT token?
           bne.s    not_afloat
           addq.l   #4,a0           Skip mantissa
           bra.s    get_token
*
not_afloat cmp.b    #136,d0         NAME token?
           bne.s    not_name
           cmp.w    0(a0,a6.l),d1   Is it the target?
           bne.s    next_token
           move.w   d2,0(a0,a6.l)
           bra.s    next_token
*
not_name   cmp.b    #139,d0         STRING token?
           beq.s    got_string
           cmp.b    #140,d0         TEXT token?
           bne.s    not_text
got_string moveq    #3,d0           Minimum length
           add.w    0(a0,a6.l),d0   Add true length
           bclr     #0,d0           Make address even
           adda.w   d0,a0           Implicitly extends D0
           bra.s    get_token
*
not_text   cmp.b    #132,d0         SYMBOL token?
           bne.s    not_symbol
           cmpi.b   #10,-1(a0,a6.l) End of line?
           bne.s    get_token
           bra.s    next_token      Skip line length
*
not_symbol cmp.b    #141,d0         NEWLINE token?
           bne.s    get_token       No - skip all word tokens
           move.w   0(a0,a6.l),d5   Grab new line number
           bra.s    next_token
*
all_done   moveq    #0,d0           No error to report
           rts
           end
